import { join } from '@ember/runloop';
import { expectTypeOf } from 'expect-type';

class Foo {
  test(_foo, _bar, _baz) {
    return 1;
  }

}

let foo = new Foo(); // With only function

expectTypeOf(join((_foo, _bar, _baz) => {
  return 1;
}, 1, true)).toEqualTypeOf();
expectTypeOf(join((_foo, _bar, _baz) => {
  return 1;
}, 1, true, 'string')).toEqualTypeOf();
join(_foo => {
  return 1; // @ts-expect-error invalid argument
}, 'string'); // With target and function

expectTypeOf(join(foo, function (_foo, _bar, _baz) {
  expectTypeOf(this).toEqualTypeOf();
  return 1;
}, 1, true)).toEqualTypeOf();
expectTypeOf(join(foo, function (_foo, _bar, _baz) {
  return 1;
}, 1, true, 'string')).toEqualTypeOf(); // @ts-expect-error invalid args

join(foo, function (_foo, _bar, _baz) {
  return 1;
}, 1, 'string'); // With function string reference

expectTypeOf(join(foo, 'test', 1, true)).toEqualTypeOf();
expectTypeOf(join(foo, 'test', 1, true, 'string')).toEqualTypeOf(); // @ts-expect-error Invalid args

join(foo, 'test', 'string');