import { run } from '@ember/runloop';
import { expectTypeOf } from 'expect-type';

class Foo {
  test(_foo, _bar, _baz) {
    return 1;
  }

}

let foo = new Foo(); // With only function

expectTypeOf(run((_foo, _bar, _baz) => {
  return 1;
}, 1, true, undefined)).toEqualTypeOf();
expectTypeOf(run((_foo, _bar, _baz) => {
  return 1;
}, 1, true, 'string')).toEqualTypeOf();
run(_foo => {
  return 1; // @ts-expect-error invalid argument
}, 'string'); // With target and function

expectTypeOf(run(foo, function (_foo, _bar, _baz) {
  expectTypeOf(this).toEqualTypeOf();
  return 1;
}, 1, true)).toEqualTypeOf();
expectTypeOf(run(foo, function (_foo, _bar, _baz) {
  return 1;
}, 1, true, 'string')).toEqualTypeOf(); // @ts-expect-error invalid args

run(foo, function (_foo, _bar, _baz) {
  return 1;
}, 1, 'string', true); // With function string reference

expectTypeOf(run(foo, 'test', 1, true, 'string')).toEqualTypeOf();
expectTypeOf(run(foo, 'test', 1, true)).toEqualTypeOf(); // @ts-expect-error Invalid args

run(foo, 'test', 'string');