import { schedule } from '@ember/runloop';
import { expectTypeOf } from 'expect-type';

class Foo {
  test(_foo, _bar, _baz) {
    return 1;
  }

}

let foo = new Foo(); // With only function

expectTypeOf(schedule('my-queue', (_foo, _bar, _baz) => {
  return 1;
}, 1, true, undefined)).toEqualTypeOf();
expectTypeOf(schedule('my-queue', (_foo, _bar, _baz) => {
  return 1;
}, 1, true, 'string')).toEqualTypeOf();
schedule('my-queue', _foo => {
  return 1;
}, // @ts-expect-error invalid argument
'string'); // With target and function

expectTypeOf(schedule('my-queue', foo, function (_foo, _bar, _baz) {
  expectTypeOf(this).toEqualTypeOf();
  return 1;
}, 1, true)).toEqualTypeOf();
expectTypeOf(schedule('my-queue', foo, function (_foo, _bar, _baz) {
  return 1;
}, 1, true, 'string')).toEqualTypeOf(); // @ts-expect-error invalid args

schedule('my-queue', foo, function (_foo, _bar, _baz) {
  return 1;
}, 1, 'string', true); // With function string reference

expectTypeOf(schedule('my-queue', foo, 'test', 1, true, 'string')).toEqualTypeOf();
expectTypeOf(schedule('my-queue', foo, 'test', 1, true)).toEqualTypeOf(); // @ts-expect-error Invalid args

schedule('my-queue', foo, 'test', 'string');